<template>
  <div>
    <form>
      <div class="form-row">
        <div class="form-group col-md-3">
          <label>Search</label>
          <input
            class="form-control"
            placeholder="Search text fields"
            v-model="textSearch"
          />
        </div>
        <div class="form-group col-md-3">
          <label>Action type</label>
          <multiselect
            v-model="selectedActionTypes"
            :options="allActionTypes"
            :multiple="true"
            placeholder="Select one or multiple action types"
          />
        </div>
        <div class="form-group col-md-3">
          <label>Target type</label>
          <multiselect
            v-model="selectedTargetTypes"
            :options="allTargetTypes"
            :multiple="true"
            placeholder="Select one or multiple target types"
          />
        </div>
        <div class="form-group col-md-3">
          <label>Order By</label><br />
          <div class="btn-group" role="group" aria-label="Basic example">
            <select class="custom-select" v-model="orderKey">
              <option value="date">Date</option>
            </select>
            <button
              type="button"
              @click="order = order * -1"
              class="btn btn-outline-dark"
            >
              {{ order < 0 ? "Asc" : "Desc" }}
            </button>
          </div>
        </div>
      </div>
    </form>
    <table class="table table-hover table-striped features-table">
      <thead>
        <tr>
          <th>Author</th>
          <th>object</th>
          <th>object_type</th>
          <th>action_type</th>
          <th>action</th>
          <th>target_type</th>
          <th>target_details</th>
          <th>IP</th>
          <th>date</th>
        </tr>
      </thead>
      <tbody>
        <tr
          :key="event.date + event.object"
          v-for="event in filteredEvents"
        >
          <td>{{ event.author }}</td>
          <td>{{ event.object }}</td>
          <td>{{ event.object_type }}</td>
          <td>{{ event.action_type }}</td>
          <td>{{ event.action }}</td>
          <td>{{ event.target_type }}</td>
          <td>{{ event.target_details }}</td>
          <td>{{ event.IP }}</td>
          <td>{{ event.date }}</td>
        </tr>
      </tbody>
      <tfoot>
        <tr>
          <th>Author</th>
          <th>object</th>
          <th>object_type</th>
          <th>action_type</th>
          <th>action</th>
          <th>target_type</th>
          <th>target_details</th>
          <th>IP</th>
          <th>date</th>
        </tr>
      </tfoot>
    </table>
  </div>
</template>
<script>
import Multiselect from "vue-multiselect";

const uniqAndSort = (array) => {
  return Array.from(new Set(array)).filter(Boolean).sort();
};

let searchDefaults = {
  order: -1,
  orderKey: "date",
  selectedActionTypes: [],
  selectedTargetTypes: [],
  textSearch: "",
};

function eqSet(as, bs) {
  if (as.length !== bs.length) return false;
  for (let a of as) if (!bs.includes(a)) return false;
  return true;
}

export default {
  components: {
    Multiselect,
  },
  data() {
    return {
      data: [],
      ...searchDefaults,
    };
  },
  async mounted() {
    const response = await fetch("./group_audit_log.json");

    this.data = await response.json();
    console.log(this.data)
    const params = new URLSearchParams(window.location.search);

    Object.entries(searchDefaults).forEach(([key, value]) => {
      if (Array.isArray(value)) {
        const newVal = params.getAll(key);
        if (!eqSet(newVal, value)) {
          this[key] = newVal;
        }
        return;
      }

      const newVal = params.get(key);

      if (newVal && newVal !== value) {
        this[key] = newVal;
      }
    });

  },
  updated() {
    const params = new URLSearchParams();
    Object.entries(searchDefaults).forEach(([key, value]) => {
      let newVal = this[key];

      if (Array.isArray(value)) {
        if (!eqSet(newVal, value)) {
          newVal.forEach((x) => {
            params.append(key, x);
          });
        }
        return;
      }

      if (newVal && newVal !== value) {
        params.set(key, newVal);
      }
    });
    window.history.replaceState(
      {},
      "",
      window.location.protocol +
        "//" +
        window.location.host +
        window.location.pathname +
        "?" +
        params.toString()
    );
  },computed: {
    allActionTypes() {
      return uniqAndSort(
        this.events.map((event) => event.action_type).flat()
      );
    },
    allTargetTypes() {
      return uniqAndSort(
        this.events.map((event) => event.target_type).flat()
      );
    },
    searchLower() {
      return this.textSearch.toLocaleLowerCase();
    },
    events() {
      console.log(this.data);
      return this.data;
    },
    filteredEvents() {
      console.log("muh");
      return this.events
        .filter((event) => {
          let visible = true;

          if (visible && this.selectedTargetTypes.length) {
            visible =
              visible &&
              ( this.selectedTargetTypes.includes(event.target_type)
              );
          }

          if (visible && this.selectedActionTypes.length) {
            visible =
              visible &&
              ( this.selectedActionTypes.includes(event.action_type)
              );
          }

          if (visible && this.textSearch) {

            visible =
              visible &&
              (event.author.toLocaleLowerCase().includes(this.searchLower) || event.object.toLocaleLowerCase().includes(this.searchLower) || event.target_details.toLocaleLowerCase().includes(this.searchLower) );

          }
          return visible;
        })
        .sort((a, b) => {
          const valA = a[this.orderKey];
          const valB = b[this.orderKey];

          if (valA === valB) {
            return 0;
          }

          return (valB < valA ? -1 : 1) * this.order;
        });
    },
  },
};
</script>
